#!/bin/bash
# Created by Topology-Converter v{{ version }}
#    Template Revision: v4.7.1

function error() {
  echo -e "\e[0;33mERROR: The Zero Touch Provisioning script failed while running the command $BASH_COMMAND at line $BASH_LINENO.\e[0m" >&2
}
trap error ERR

SSH_URL="http://{{ devices[0].mgmt_ip }}/authorized_keys"
#Setup SSH key authentication for Ansible
mkdir -p /home/cumulus/.ssh
wget -O /home/cumulus/.ssh/authorized_keys $SSH_URL

# unexpire cumulus user password (new for 4.2)
passwd -x 99999 cumulus
echo 'cumulus:CumulusLinux!' | chpasswd

# make user cumulus passowrdless sudo
echo "cumulus ALL=(ALL) NOPASSWD:ALL" > /etc/sudoers.d/10_cumulus

#enable all debian sources & netq apps3 repo
sed -i 's/#deb/deb/g' /etc/apt/sources.list
wget -O pubkey https://apps3.cumulusnetworks.com/setup/cumulus-apps-deb.pubkey
apt-key add pubkey
rm pubkey

# configure netq
{% for device in devices %}
{%   if device.hostname == "netq-ts"-%}
{%     if device.mgmt_ip is defined -%}
cat << EOT > /etc/netq/netq.yml
netq-agent:
  server: {{ device.mgmt_ip }}
  vrf: mgmt
  wjh: true
netq-cli:
  server: {{ device.mgmt_ip }}
  vrf: mgmt

EOT
{%     endif -%}
{%   endif -%}
{% endfor -%}

# allow ntp to make large steps at service restart
echo "tinker panic 0" >> /etc/ntp.conf
systemctl enable ntp@mgmt

# install air agent
apt update -qy
apt install -qy python3-pip
git clone https://gitlab.com/cumulus-consulting/air/air-agent.git
cd air-agent
sudo ./install.sh -v mgmt

# Pre-login banner
cat <<EOT > /etc/issue
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   Welcome to \n
   Login with: cumulus/CumulusLinux!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

EOT
cp /etc/issue /etc/issue.net
chmod 755 /etc/issue /etc/issue.net

reboot
exit 0
#CUMULUS-AUTOPROVISIONING
